<?php

	global $wpdb;

	sabre_DB_update();

	sabre_auto_clean();

	// Check the news
	$sabre_opt = get_option('sabre_opt');
	$last_spam_check = $sabre_opt['last_spam_check'];
	$new_spams = $wpdb->get_var("SELECT COUNT(*) FROM `" . sabre_Table . "` WHERE `status`= 'ko' AND `last_mod` > " . strftime("'%Y-%m-%d %H:%M:%S'", (int) $last_spam_check));
	if ($new_spams)
		$new_spams = " ($new_spams)";
	else
		$new_spams = "";

	$last_approved_check = $sabre_opt['last_approved_check'];
	$new_approved = $wpdb->get_var("SELECT COUNT(*) FROM `" . sabre_Table . "` WHERE `status`= 'ok' AND `last_mod` > " . strftime("'%Y-%m-%d %H:%M:%S'", (int) $last_approved_check));
	if ($new_approved)
		$new_approved = " ($new_approved)";
	else
		$new_approved = "";

	// $sabre_tabs = array ("option" => __("General Options", 'sabre'), "spam" => __("Blocked Registrations", 'sabre') . $new_spams, "approved" => __("Approved Registrations", 'sabre') . $new_approved, "logs" => __("Sabre Logs", 'sabre'), "about" => __("About", 'sabre'));
	$sabre_tabs = array ("option" => __("General Options", 'sabre'), "spam" => __("Blocked Registrations", 'sabre') . $new_spams, "approved" => __("Approved Registrations", 'sabre') . $new_approved, "about" => __("About", 'sabre'));

	if (isset($_REQUEST['sabre_action']) && !empty($sabre_tabs[$_REQUEST['sabre_action']]))
		$cur_tab = $_REQUEST['sabre_action'];
	else
		$cur_tab = "option";

	echo '<ul id="sabre_menu">';
	$url = $_SERVER['PHP_SELF'] . "?page=sabre" . "&sabre_action=";
	foreach ($sabre_tabs as $tab => $name) {
		if ($cur_tab == $tab)
			echo "<li class=\"current\">$name</li>";
		else
			echo "<li><a href=\"" . $url . $tab . "\">$name</a></li>";
	}

	echo '</ul>';

	switch ($cur_tab)
	{
			case 'spam'  :
			case 'approved' :

			$regmsg = '';

			if ($_REQUEST['add_regs'] && $_REQUEST['userid'])
				$regmsg = sabre_add_reg_user($_REQUEST['userid']);

			if ($_REQUEST['add_regs'] && $_REQUEST['all_users'])
				$regmsg = sabre_add_all_users();

			if ($_REQUEST['del_regs'] && $_REQUEST['list_sel'])
				$regmsg = sabre_del_reg_user($_REQUEST['list_sel']);

			if ($_REQUEST['del_unregs'] && $_REQUEST['del_days']) {
				$regmsg = sabre_del_unreg_user($_REQUEST['del_days']);
				if ($_REQUEST['del_auto'])
					$sabre_opt['purge_days'] = (int)$_REQUEST['del_days'];
                }

			if ($cur_tab == 'spam') {
				$where = "`status` = 'ko'";
				$sabre_opt['last_spam_check'] = time();
				$title = __("Invalid registration list", 'sabre');
			}
			else {
				$where = "`status` IN ('ok', 'to confirm')";
				$sabre_opt['last_approved_check'] = time();
				$title = __("Valid registration list", 'sabre');
			}

			update_option('sabre_opt', $sabre_opt);
			$query_limit_str = $query_limit = max(20, @$_REQUEST['rows_per_page']);
			if (@$_REQUEST['skip_rows'])
				$query_limit_str = $_REQUEST['skip_rows'] . ", " . ($_REQUEST['skip_rows'] + $query_limit);

			$query = "SELECT `id`, `user`, `email`, `user_IP`, `last_mod`, `msg`, `user_id`, `status` FROM `" . sabre_Table . "` WHERE " . $where . " ORDER BY `last_mod` DESC LIMIT " . $query_limit_str;
			$spam_rows = $wpdb->get_results($query);

			echo '<div class="wrap sabre_notopmargin">';

			if (!empty($regmsg)) {
				echo '<div id="message" class="updated fade"><p>' . $regmsg . '</p></div>';
				}

			echo '<h2>' . $title . '</h2>';

			echo '<p class="sabre_form"><form id="sabre_list_form" name="sabre_list_form" method="get" action="' . $_SERVER['PHP_SELF'] .'">';

			if (function_exists('wp_nonce_field'))
				wp_nonce_field('sabre-manage_registration');

			if ($cur_tab == 'approved') {
				echo '<fieldset class="options">';
				echo '<legend>' . __("Manual registration", 'sabre') . '</legend>';
				echo '<input type="submit" name="add_regs" id="add_regs" value="' . __("Add", 'sabre') . '" />';
				echo '<input type="text" id="userid" name="userid" size="3"/> ' . __("Enter WordPress user ID or check the box to add all existing WordPress users ", 'sabre');
				echo '<input type="checkbox" name="all_users" id="all_users" value="yes" />';
				echo '</fieldset>';
				echo '<fieldset class="options">';
				echo '<legend>' . __("Manual deregistration", 'sabre') . '</legend>';
				echo '<input type="submit" name="del_regs" id="del_regs" value="' . __("Unregister", 'sabre') . '"/>' . __("Unregister selected users", 'sabre');
				echo '</fieldset>';
			}

			if ($cur_tab == 'spam') {
				echo '<fieldset class="options">';
				echo '<legend>' . __("Purge log", 'sabre') . '</legend>';
				echo '<input type="submit" name="del_unregs" id="del_unregs" value="' . __("Delete", 'sabre') . '" /> ';
				echo __("Log older than", 'sabre');
				echo ' <input type="text" value="' . $sabre_opt['purge_days'] . '" id="del_days" name="del_days" size="3"/> ' . __("days", 'sabre');
				echo ' (' . __('And do it automatically now', 'sabre') . '<input type="checkbox" name="del_auto" id="del_auto" value="yes" checked />)';
				echo '</fieldset>';
			}

			echo '<fieldset class="options">';
			echo '<legend>' . __("Browse", 'sabre') . '</legend>';
			echo '<input type="hidden" name="page" id="page" value="sabre" />';
			echo '<input type="hidden" name="sabre_action" id="sabre_action" value="' . $cur_tab . '" />';
			echo '<input type="submit" name="display_regs" id="display_regs" value="' . __("Display", 'sabre') . '" />';
			echo '<input type="text" id="rows_per_page" name="rows_per_page" value="' . $query_limit . '" size="3"/> ' . __("lines per page, skipping first: ", 'sabre');
			echo '<input type="text" id="skip_rows" name="skip_rows" value="' . intval(@$_REQUEST['skip_rows']) . '" size="3" />';
			echo '</fieldset>';

			echo '<table id="sabre_spam_list" width="100%" cellpadding="3" cellspacing="3">';
			echo '<tr class="sabre_th"><th>' . __('Id', 'sabre') . '</th><th>' . __('User name', 'sabre') . '</th><th>' . __('User E-mail', 'sabre') . '</th><th>' . __('User IP', 'sabre') . '</th><th>' . __('When', 'sabre') . '</th>' . ($cur_tab == 'spam' ? '' : '<th>' . __('Status', 'sabre') . '</th>') . '<th>' . ($cur_tab == 'spam' ? __('Errors', 'sabre') : __('User ID', 'sabre')) . '</th></tr>';

			if (is_array($spam_rows)) {
				$rowid = 0;
				foreach ($spam_rows as $row) {
					$rowid += 1;
					echo '<tr ' . ($rowid % 2 ? 'class="sabre_odd">' : 'class="sabre_even">');
					if ($cur_tab == 'spam')
						echo '<td>' . $row->id . '</td>';
					else
						echo '<th scope="row"><input type="checkbox" name="list_sel[' . $row->id . ']" id="list_sel[' . $row->id . ']" value="' . $row->id . '" />' . $row->id . '</th>';
					echo '<td>';
					echo $row->user;
					echo '</td><td>';
					echo $row->email;
					echo '</td><td>';
					echo $row->user_IP;
					echo '</td><td>';
					echo $row->last_mod;
					echo '</td><td>';
					if ($cur_tab == 'spam') {
						$msgs= "";
						if (!empty($row->msg)) {
							$msgs_array = unserialize($row->msg);
							if (is_array($msgs_array))
								foreach ($msgs_array as $msg_type => $msg) {
									$msgs .= $msg;
									$msgs .= '<br />';
								}
						}
						echo $msgs;
					}
					else {
						echo $row->status;
						echo '</td><td>';
						echo '<a href="' . get_bloginfo('wpurl') . '/wp-admin/user-edit.php?user_id=' . $row->user_id . '" >' . $row->user_id . '</a>';
					}
					echo '</td></tr>';
				}
			}

			echo '</table>';
			echo '</form></p>';
			echo '</div>';

			break;

			case 'logs' :

			echo '<div class="wrap sabre_notopmargin">';
			echo '<h2>' . __("Events history", 'sabre') . '</h2>';

			echo '</div>';

			break;

			case 'about' :

			require_once(dirname(__FILE__) . "/sabre_about.php");

			break;


		case 'option':
		default:

			$total_pending = $wpdb->get_var("SELECT COUNT(*) FROM `" . sabre_Table . "` WHERE `status` = 'to confirm'");

			echo '<div class="wrap sabre_notopmargin">';

			if (sabre_save_options($_POST))
				echo '<div id="message" class="updated fade"><p>' . __('Options successfully saved.', 'sabre') . '</p></div>';

			echo '<h2>' . __("Quick figures", 'sabre') . '</h2>';
			echo '<ul>';
			echo '<li>' . __('Total number of registrations stopped:', 'sabre') . '  <strong>' . (int)$sabre_opt['total_stopped'] . '</strong></li>';
			echo '<li>' . __('Total number of registrations accepted:', 'sabre') . '  <strong>' . (int)$sabre_opt['total_accepted'] . '</strong></li>';
			echo '<li>' . __('Number of pending confirmation:', 'sabre') . '  <strong>' . (int)$total_pending . '</strong></li>';
			echo '</div>';

			$sabre = get_option('sabre_captcha');
			$sabre_confirm = get_option('sabre_confirm');
			$sabre_math = get_option('sabre_math');
			$sabre_seq = get_option('sabre_seq');
			$sabre_stealth = get_option('sabre_stealth');
			$sabre_opt = get_option('sabre_opt');

			echo '<div class="wrap sabre_notopmargin">';
			echo '<h2>' . __("General Options", 'sabre') . '</h2>';

			echo '<form id="sabre_option_form" name="sabre_option_form" method="post" action="' . $_SERVER['PHP_SELF'] . '?page=sabre&sabre_action=option">';
			
			if (function_exists('wp_nonce_field'))
				wp_nonce_field('sabre-manage_option');

			echo '<fieldset class="options">';
			echo '<legend>' . __("Captcha options", 'sabre') . '</legend>';
			echo '<table>';
			echo '<tr><td><label for="sabre_enable_captcha">' . __('Enable captcha test:', 'sabre') . '</label></td><td><input type="checkbox" ' . sabre_checked($sabre['enable_captcha'], 'true') . ' name="sabre_enable_captcha" id="sabre_enable_captcha" value="true" /></td><td>' . __('(Turn captcha generation on/off)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_acceptedChars">' . __('Accepted characters:', 'sabre') . '</label></td><td><input type="text" size="50" name="sabre_acceptedChars" id="sabre_acceptedChars" value="' . $sabre['acceptedChars'] . '" /></td><td>' . __('(List of valid characters for code generation)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_stringlength">' . __('String length:', 'sabre') . '</label></td><td><input type="text" size="2" name="sabre_stringlength" id="sabre_stringlength" value="' . $sabre['stringlength'] . '" /></td><td>' . __('(Number of characters for code)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_contrast">' . __('Contrast:', 'sabre') . '</label></td><td><input type="text" size="2" name="sabre_contrast" id="sabre_contrast" value="' . $sabre['contrast'] . '" /></td><td>' . __('(The higher the number, the better the contrast)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_num_polygons">' . __('Number of polygons:', 'sabre') . '</label></td><td><input type="text" size="2" name="sabre_num_polygons" id="sabre_num_polygons" value="' . $sabre['num_polygons'] . '" /></td><td>' . __('(Number of triangles to draw.  0 = none)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_num_ellipses">' . __('Number of ellipses:', 'sabre') . '</label></td><td><input type="text" size="2" name="sabre_num_ellipses" id="sabre_num_ellipses" value="' . $sabre['num_ellipses'] . '" /></td><td>' . __('(Number of ellipses to draw.  0 = none)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_num_lines">' . __('Number of lines:', 'sabre') . '</label></td><td><input type="text" size="2" name="sabre_num_lines" id="sabre_num_lines" value="' . $sabre['num_lines'] . '" /></td><td>' . __('(Number of lines to draw.  0 = none)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_num_dots">' . __('Number of dots:', 'sabre') . '</label></td><td><input type="text" size="2" name="sabre_num_dots" id="sabre_num_dots" value="' . $sabre['num_dots'] . '" /></td><td>' . __('(Number of dots to draw.  0 = none)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_min_thickness">' . __('Min. thickness:', 'sabre') . '</label></td><td><input type="text" size="2" name="sabre_min_thickness" id="sabre_min_thickness" value="' . $sabre['min_thickness'] . '" /></td><td>' . __('(Minimum thickness of lines in pixels)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_max_thickness">' . __('Max. thickness:', 'sabre') . '</label></td><td><input type="text" size="2" name="sabre_max_thickness" id="sabre_max_thickness" value="' . $sabre['max_thickness'] . '" /></td><td>' . __('(Maximum thickness of lines in pixels)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_min_radius">' . __('Min. radius:', 'sabre') . '</label></td><td><input type="text" size="2" name="sabre_min_radius" id="sabre_min_radius" value="' . $sabre['min_radius'] . '" /></td><td>' . __('(Minimum radius of ellipses)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_max_radius">' . __('Max. radius:', 'sabre') . '</label></td><td><input type="text" size="2" name="sabre_max_radius" id="sabre_max_radius" value="' . $sabre['max_radius'] . '" /></td><td>' . __('(Maximum radius of ellipses)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_object_alpha">' . __('Object alpha:', 'sabre') . '</label></td><td><input type="text" size="2" name="sabre_object_alpha" id="sabre_object_alpha" value="' . $sabre['object_alpha'] . '" /></td><td>' . __('(How opaque should the obscuring objects be. 0 is opaque, 127 is transparent)', 'sabre') . '</td></tr>';
			echo '</table>';
			echo '</fieldset>';
			echo '<fieldset class="options">';
			echo '<legend>' . __("Math options", 'sabre') . '</legend>';
			echo '<table>';
			echo '<tr><td><label for="sabre_enable_math">' . __('Enable math test:', 'sabre') . '</label></td><td><input type="checkbox" ' . sabre_checked($sabre_math['enable_math'], 'true') . ' name="sabre_enable_math" id="sabre_enable_math" value="true" /></td><td>' . __('(Turn math control on/off)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_math_ops">' . __('Accepted operations:', 'sabre') . '</label></td><td><input type="text" size="2" name="sabre_math_ops" id="sabre_math_ops" value="' . $sabre_math['math_ops'] . '" /></td><td>' . __('(List of valid operations for math test)', 'sabre') . '</td></tr>';
			echo '</table>';
			echo '</fieldset>';
			echo '<fieldset class="options">';
			echo '<legend>' . __("Sequence of tests", 'sabre') . '</legend>';
			echo '<table>';
			echo '<tr><td><label for="sabre_test_seq">' . __('Tests to perform:', 'sabre') . '</label></td><td><select size="1" name="sabre_test_seq" id="sabre_test_seq">';
			echo '<option value="All" ' . sabre_selected($sabre_seq, 'All') . ' >' . __('All', 'sabre') . '</option>';
			echo '<option value="Random" ' . sabre_selected($sabre_seq, 'Random') . ' >' . __('Randomly', 'sabre') . '</option>';
			echo '</select></td><td>' . __('(How do we use the above tests?)', 'sabre') . '</td></tr>';
			echo '</table>';
			echo '</fieldset>';
			echo '<fieldset class="options">';
			echo '<legend>' . __("Stealth options", 'sabre') . '</legend>';
			echo '<table>';
			echo '<tr><td><label for="sabre_enable_stealth">' . __('Enable stealth test:', 'sabre') . '</label></td><td><input type="checkbox" ' . sabre_checked($sabre_stealth['enable_stealth'], 'true') . ' name="sabre_enable_stealth" id="sabre_enable_stealth" value="true" /></td><td>' . __('(Turn silent control on/off)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_enable_js">' . __('Block if Javascript unsupported:', 'sabre') . '</label></td><td><input type="checkbox" ' . sabre_checked($sabre_stealth['js_support'], 'true') . ' name="sabre_enable_js" id="sabre_enable_js" value="true" /></td><td>' . __('(Consider that a lack of Javascript capabilities is a spambot\'s footprint)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_timeout">' . __('Session time out:', 'sabre') . '</label></td><td><input type="text" size="2" name="sabre_timeout" id="sabre_timeout" value="' . $sabre_stealth['session_timeout'] . '" /></td><td>' . __('(Max. time in seconds before session expires)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_speed">' . __('Speed limit:', 'sabre') . '</label></td><td><input type="text" size="2" name="sabre_speed" id="sabre_speed" value="' . $sabre_stealth['speed_limit'] . '" /></td><td>' . __('(Min. time in seconds to fill the registration form)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_banned_IP">' . __('Check DNS Blacklists:', 'sabre') . '</label></td><td><input type="checkbox" ' . sabre_checked($sabre_stealth['check_banned_IP'], 'true') . ' name="sabre_banned_IP" id="sabre_banned_IP" value="true" /></td><td>' . __('(Control if user IP address is blacklisted on DNSBL servers)', 'sabre') . '</td></tr>';
			echo '</table>';
			echo '</fieldset>';
			echo '<fieldset class="options">';
			echo '<legend>' . __("Confirmation options", 'sabre') . '</legend>';
			echo '<table>';
			echo '<tr><td><label for="sabre_enable_confirm">' . __('Enable user confirmation:', 'sabre') . '</label></td><td><input type="checkbox" ' . sabre_checked($sabre_confirm['enable_confirm'], 'true') . ' name="sabre_enable_confirm" id="sabre_enable_confirm" value="true" /></td><td>' . __('(Ask user to confirm registration within x days)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_confirm_period">' . __('Number of days:', 'sabre') . '</label></td><td><input type="text" size="2" name="sabre_confirm_period" id="sabre_confirm_period" value="' . (1 > (int)$sabre_confirm['period'] ? 3 : (int)$sabre_confirm['period']) . '" /></td><td>' . __('(Period of time for the user to confirm his registration)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_no_entry">' . __('Deny early sign-in:', 'sabre') . '</label></td><td><input type="checkbox" ' . sabre_checked($sabre_confirm['no_entry'], 'true') . ' name="sabre_no_entry" id="sabre_no_entry" value="true" /></td><td>' . __("(Don't allow users to sign in before confirmation)", 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_delete_user">' . __('Suppress unregistered users:', 'sabre') . '</label></td><td><input type="checkbox" ' . sabre_checked($sabre_confirm['delete_user'], 'true') . ' name="sabre_delete_user" id="sabre_delete_user" value="true" /></td><td>' . __("(Delete user account when registration is canceled)", 'sabre') . '</td></tr>';
			echo '</table>';
			echo '</fieldset>';
			echo '<fieldset class="options">';
			echo '<legend>' . __("Miscellaneous options", 'sabre') . '</legend>';
			echo '<table>';
			echo '<tr><td><label for="sabre_show_banner">' . __('Show banner:', 'sabre') . '</label></td><td><input type="checkbox" ' . sabre_checked($sabre_opt['show_banner'], 'true') . ' name="sabre_show_banner" id="sabre_show_banner" value="true" /></td><td>' . __('(Mention Sabre at the bottom of the registration form)', 'sabre') . '</td></tr>';
			echo '<tr><td><label for="sabre_suppress_sabre">' . __('Suppress Sabre:', 'sabre') . '</label></td><td><input type="checkbox" ' . sabre_checked($sabre_opt['suppress_sabre'], 'true') . ' name="sabre_suppress_sabre" id="sabre_suppress_sabre" value="true" /></td><td>' . __('(Delete all Sabre stuff when deactivating the plugin - Use with caution!)', 'sabre') . '</td></tr>';
			echo '</table>';
			echo '</fieldset>';

			echo '<input type="submit" name="sabre_option_save" value="'. __("Save options", 'sabre') . '" />';
			echo '</form>';

			echo '</div>';
			break;
	}
?>